------------------------------------------------------------------------------------------------------------------------------------------------------
--                                          Capitulo 01 - Laboratrio - Sql Expert - Controlando Usurios                                           --
--                                               Treinamento para certificao Fundamentals SQL Oracle                                              --
--                                           Pedro F. Carvalho - DBA / Analista de Sistemas / Desenvolvedor                                         --
--                                         Site : www.pedrofcarvalho.com.br   E-mail : contato@pedrofcarvalho.com.br                                --
------------------------------------------------------------------------------------------------------------------------------------------------------

/* Exerccio 01
Qual o privilgio para se logar no Oracle Server?  um privilgio de Sistema ou de Objeto
*/

CREATE SESSION -- privilgio de sistema

/* Exerccio 02
Qual o privilgio que voce deve ter para criar uma tabela ?
*/

CREATE TABLE -- privilgio de sistema


/* Exerccio 03
Se voc quer criar uma tabela e quer passar esse privilgio as demais pessoas qual o comando utilizado ?
*/

with grant option
grant select on hr.departments to X with grant option


/* Exerccio 04
Voc  um DBA e criou alguns usurios com o mesmo privilgio.
O que  usado para economizar neste seu trabalho ?
*/

-- privilgios de sistema ou objeto X 24 
-- ROLE agrupamento de privilgios para voc desinar a um usurio


/* Exerccio 05
Qual o comando para alterar sua senha ?
*/

alter user pedro identified by 12345678 immediate;
-- eliminar o erro de senha expirada


/* Exerccio 06
O user21  proprietrio da tabela EMP e designa privilgio de delete ao User22 usando WITH GRANT OPTION.
User22 designa delete para o user23 na tabela EMP. User21 retira esse privilgio do user22.
Quem pode deletar dados da tabela EMP
*/

user21 -> delete emp para p usuario user22 with grant option
user22 -> libera esse mesmo privilgio para o user23
user21 -> retira privilegio do user22; -- automaticamente vo perder esse acesso

user21

/* Exerccio 07
Voce quer designar privilegio de update para o usuario scoot na tabela departments.
Voce quer permitir que o usuario scott de esses mesmo privilgios a outro usurios. 
Qual o comando que voc emite ?
*/

grant update on departments to scott with grant option;


/* Exerccio 08
Crie 3 usurios A1 A2 e A3 e de permisso de connect e create session
Crie uma tabela com o usuario A1 e de permisso nela para o usurio A2 dar select e para que ele possa dar essa mesma permisso a outros
Tente dar select com o usurio A3 nesta tabela.
Conectado com o usuario A2 de permisso de insert na tabela para o usuario A3
Conectado com o usuario A2 de permisso de select na tabela para o usuario A3
conectado com o usuario A1 revogue o privilgio do usuario A2 na tabela.
*/

create user a1 identified by 12345678;
create user a2 identified by 12345678;
create user a3 identified by 12345678;

grant connect to a1;
grant connect to a2;
grant connect to a3;

grant create session to a1;
grant create session to a2;
grant create session to a3;

grant create table to a1;

drop user a1;
drop user a2;
drop user a3;




/* Exerccio 09
Com o usurio A1 crie outra tabela e de permisso de select, insert e update para o A2
*/


/* Exerccio 10
Revogue os mesmos privilgios do exerccio 09
*/


/* Exerccio 11
Com usurio HR de permisso de consulta e insert na tabela departments para o usurio a1 e a2
*/

grant select, insert on hr.departments to a1;

/* Exerccio 12
Revoke os privilegios do exerccio 11
*/

revoke select, insert on hr.departments from a1;


-- Passos de estudos
-- 1 - Assistir esta video aula 1x
-- 2 - Assistir a video aula agora fazendo os scritps 1x
-- 5 - Realizar o simulado online
       
-- Abraos e bons estudos !
       






